#ifndef CFG_H
#define CFG_H

/* cfg - persistent configuration properties interface
 */

#include <stdio.h>
#include <mba/iterator.h>

struct cfg;

struct cfg *cfg_new(void);
void cfg_del(void *this);

int cfg_load(struct cfg *this, const char *filename);
int cfg_load_str(struct cfg *this, const char *src);
int cfg_load_env(struct cfg *this);
int cfg_load_cgi_query_string(struct cfg *this, const char *qs);
int cfg_store(struct cfg *this, const char *filename);
int cfg_write(struct cfg *this, FILE *stream);

int cfg_get_str(struct cfg *this, char *dst, int dn, const char *def, const char *name);
int cfg_vget_str(struct cfg *this, char *dst, int dn, const char *def, const char *name, ...);
int cfg_get_short(struct cfg *this, short *dst, short def, const char *name);
int cfg_vget_short(struct cfg *this, short *dst, short def, const char *name, ...);
int cfg_get_int(struct cfg *this, int *dst, int def, const char *name);
int cfg_vget_int(struct cfg *this, int *dst, int def, const char *name, ...);
int cfg_get_long(struct cfg *this, long *dst, long def, const char *name);
int cfg_vget_long(struct cfg *this, long *dst, long def, const char *name, ...);
void cfg_iterate(void *cfg, iter_t *iter);
const char *cfg_next(void *cfg, iter_t *iter);

#endif /* CFG_H */

